#ifndef _GMIDI_OUT_H
#define _GMIDI_OUT_H

#include "../GMidiin/GMidiCommon.h"

#define MIDIOUT_BUFFER_SIZE 32

#define ON_FULL_WAIT   0x00
#define ON_FULL_RETURN 0x01

#define MIDIOUT_SEND_FULL 0x00
#define MIDIOUT_SEND_OK   0x01


class GMidiout
{
	public:
		GMidiout();
		void begin();
		void noteOn(unsigned char channel, unsigned char noteNo, unsigned char velocity);
		void noteOff(unsigned char , unsigned char noteNo, unsigned char velocity);
		void cc(unsigned char channel, unsigned char ccNo, unsigned char value);
		void prgChange(unsigned char channel, unsigned char prgNo);
		void pitchBend(unsigned char channel, int value);
		void sysex(unsigned char *sysex, unsigned char len);
		unsigned char setSendByte(unsigned char setSendByte, unsigned char onFull);
		void sendByte();

	private:
		volatile unsigned char *outBuffer;
		volatile unsigned char writePtr;
		volatile unsigned char readPtr;
};

extern GMidiout Midiout;

#endif //_GMIDI_OUT_H
