#include "GMidioutDummy.h"
#include <HardwareSerial.h>
#include <stdio.h>
/* ***********************
 GMidiOutに対して、
 ダミーとしてprintを行うクラス

************************ */

char gNoteStr[5];

GMidioutDummy::GMidioutDummy()
{
	// シリアルポートを開く
}


void GMidioutDummy::noteOn(unsigned char channel, unsigned char noteNo, unsigned char velocity)
{
	char tmp[20];
	sprintf(tmp,"note on  (%d) %d[%s],%d\n",channel + 1,noteNo,(char*)getNoteString(noteNo),velocity);
	Serial.print(tmp);
}

void GMidioutDummy::noteOff(unsigned char channel, unsigned char noteNo, unsigned char velocity)
{
	char tmp[20];
	sprintf(tmp,"note off (%d) %d[%s],%d\n",channel + 1,noteNo,(char*)getNoteString(noteNo),velocity);
	Serial.print(tmp);
}


void GMidioutDummy::cc(unsigned char channel, unsigned char ccNo, unsigned char value)
{
	char tmp[20];
	sprintf(tmp,"cc       (%d) %x:%x\n",channel + 1,ccNo,value);
	Serial.print(tmp);
}


void GMidioutDummy::prgChange(unsigned char channel, unsigned char prgNo)
{
}


void GMidioutDummy::pitchBend(unsigned char channel, int value)
{
}


void GMidioutDummy::sysex(unsigned char *sysex, unsigned char len)
{
}


void GMidioutDummy::sendByte()
{
}


unsigned char GMidioutDummy::setSendByte(unsigned char byte, unsigned char onFull)
{
	return MIDIOUT_SEND_OK;
}


void GMidioutDummy::begin()
{
	// シリアルポートを開く
	Serial.begin(57600);
}

char* GMidioutDummy::getNoteString(unsigned char noteNo)
{

	char* strNoteTbl = "C C#D D#E F F#G G#A A#B ";

	if(noteNo < (12 * 10))
	{	gNoteStr[0] = ' ';	}
	else
	{
		gNoteStr[0] = '0' + (noteNo / (12 * 10));
		noteNo -= (12 * 10);
	}
	
	gNoteStr[1] = '0' + noteNo /12;
	
	gNoteStr[2] = *(strNoteTbl + noteNo%12*2);
	gNoteStr[3] = *(strNoteTbl + noteNo%12*2 + 1);
	gNoteStr[4] = '\0';
	
	return(gNoteStr);
}


GMidioutDummy Midiout = GMidioutDummy();
