#ifndef _GMIDIOUTDUMMY_H
#define _GMIDIOUTDUMMY_H

#include "GMidiCommon.h"

#define MIDIOUT_BUFFER_SIZE 32

#define ON_FULL_WAIT   0x00
#define ON_FULL_RETURN 0x01

#define MIDIOUT_SEND_FULL 0x00
#define MIDIOUT_SEND_OK   0x01


class GMidioutDummy
{
	public:
		GMidioutDummy();
		void begin();
		void noteOn(unsigned char channel, unsigned char noteNo, unsigned char velocity);
		void noteOff(unsigned char , unsigned char noteNo, unsigned char velocity);
		void cc(unsigned char channel, unsigned char ccNo, unsigned char value);
		void prgChange(unsigned char channel, unsigned char prgNo);
		void pitchBend(unsigned char channel, int value);
		void sysex(unsigned char *sysex, unsigned char len);
		unsigned char setSendByte(unsigned char setSendByte, unsigned char onFull);
		void sendByte();

	private:
		char* getNoteString(unsigned char noteNo);

	private:
		volatile unsigned char *outBuffer;
		volatile unsigned char writePtr;
		volatile unsigned char readPtr;
};

extern GMidioutDummy Midiout;

#endif //_GMIDIOUTDUMMY_H
