/*
 class : VecterAn

*/
// デバッグヘッダ
#include "WProgram.h"		// hardware serialを使うために必要
#include "VectorAnalyze.h"


// コンストラクタ
VectorAnalyze::VectorAnalyze()
{
	memset(&mat,0,sizeof(mat));
// 各ステータス
	mHammer = 0;
	mMode = M_Hammer;
}


void VectorAnalyze::setFncHammer(void (*pSt)(void),void (*pEd)(void))
{
	mpHammerSt = pSt;
	mpHammerEd = pEd;
}
void VectorAnalyze::setFncSwing(void (*pGg)(int),void (*pEd)(void))
{
	mpSwinggg = pGg;
	mpSwingEd = pEd;
}

// 振り下ろしモード
void VectorAnalyze::setModeHammer()
{
	if(mMode != M_Hammer)
	{
		mMode = M_Hammer;
		mHammer = 0;
	}
}


// 振り回しモード
void VectorAnalyze::setModeSwing()
{
	if(mMode != M_Swing)
	{
		mMode = M_Swing;
		mSwing = 0;
	}
}

// データ設定
void VectorAnalyze::set(double x,double y,double z)
{
// old set
	mat.ox = mat.x;
	mat.oy = mat.y;
	mat.oz = mat.z;
	mat.otime = mat.time;

// now set
	mat.x = (int)(x * 1000);
	mat.y = (int)(y * 1000);
	mat.z = (int)(z * 1000);
	mat.time = millis();
// 判定
	if(mMode == M_Hammer)
	{
		chkHammer();
	}
	else
	{
		chkSwing();
	}

}

// 振り下ろし判定
#define HUMMERDEV 10
int VectorAnalyze::chkHammer()
{
	int vector = (mat.y - mat.oy)/((int)(mat.time - mat.otime));

	switch(mHammer)
	{
	case 0:// 降下待ち
		if(vector>HUMMERDEV)
		{
			mHamtime = mat.time;
			mHammer = 1;
			// 降下開始
			mpHammerSt();
		}
		break;
	case 1:// 降下中
		if(vector>HUMMERDEV)
		{
			if((mat.time - mHamtime) > 30)
			{
				mHammer = 2;
			}
		}
		else
		{
			mHammer = 0;
		}
		break;
	case 2:// 停止待
		if(vector<HUMMERDEV)
		{
			mHammer = 3;
			mpHammerEd();
			mHamtime = mat.time;
		}
		break;
	case 3:// wait
		if((mat.time - mHamtime) > 400)
		{
			mHammer = 0;
		}
		break;
		
	}

}


// 振り回し判定
#define SWINGDEVST 50
#define SWINGDEVED 5
int VectorAnalyze::chkSwing()
{
	int vector = abs(mat.y - mat.oy);

	switch(mSwing)
	{
	case 0:// 振り回し開始
		if(vector>SWINGDEVST)
		{
			mSwing = 1;
		}
		break;
	case 1:// 振り回し中
	case 2:// 振り回し中2
		if(vector>SWINGDEVED)
		{
			mValueSwing += (mat.time - mat.otime)/5 ;
			mValueSwing = (mValueSwing > 255 ? 255 : mValueSwing);
			mpSwinggg(mValueSwing);
		}
		else
		{
			// 3回連続で閾値以下なら、停止
			mSwing++;
		}
		break;
	case 3:// 振り回し中3
		if(vector>SWINGDEVED)
		{
			mValueSwing += (mat.time - mat.otime)/5 ;
			mValueSwing = (mValueSwing > 255 ? 255 : mValueSwing);
			mpSwinggg(mValueSwing);
			mSwing = 1;
		}
		else
		{
			// 停止
			mSwing = 0;
			mValueSwing = 0;
			mpSwingEd();
		}
		break;
	}

}
