/*****************************************************************************


*****************************************************************************/
#ifndef _VECTORANALYZE_H
#define _VECTORANALYZE_H


// ビット定数(B01010101等)を使うためのヘッダ
#include "binary.h"

typedef struct {
	int x;		// x
	int y;		// y
	int z;		// z
	int ox;		// old x
	int oy;		// old y
	int oz;		// old z
	unsigned long otime;	// 取得タイミング
	unsigned long time;		// 取得タイミング
} ATTITUDE;

class VectorAnalyze
{
	enum
	{
		M_Hammer = 0,		// 振り下ろし
		M_Swing				// 振り回し
	};

// 変数
private:
	ATTITUDE	mat;
	// mode
	char			mMode;

	//振り下ろし
	char			mHammer;
	unsigned long	mHamtime;
	
	//振り回し
	char			mSwing;
	double			mValueSwing;

	
	void (*mpHammerSt) (void);   /* 振り下ろし */
	void (*mpHammerEd) (void);   /* 振り下ろし */
	void (*mpSwinggg) (int);	 /* 振り回し中 */
	void (*mpSwingEd) (void);    /* 振り回し終 */
	
// 関数
public:
	VectorAnalyze();

	void setFncHammer(void (*pSt)(void),void (*pEd)(void));
	void setFncSwing(void (*pGg)(int),void (*pEd)(void));
	void setModeHammer();
	void setModeSwing();

	void set(double x,double y,double z);
	int chkHammer();
	int chkSwing();

};


#endif //_VECTORANALYZE_H

