// WiiMidi
// 振り回しでサンプル再生
#include "WiiRemote.h"
//#include "WProgram.h"		// hardware serialを使うために必要
#include "WMDSwingSample.h"
#include "setMidiOUt.h"

// MIDI チャンネル
#define MIDICHANNEL	9		// ch 10

// サンプル
// サンプルを鳴らす為に必要なmidiNote番号を指定
// （ES-1のコードが設定されていますが、デフォルト設定ではありません）
#define	SMP_DOWN		12*2		// ES1 part 1
#define	SMP_LEFT		12*2 +2		// ES1 part 2
#define	SMP_UP			12*2 +4		// ES1 part 3
#define	SMP_RIGHT		12*2 +5		// ES1 part 4
#define	SMP_ONE			12*2 +9		// ES1 part 6A
#define	SMP_TWO			12*2 +10	// ES1 part 6B


extern WiiRemote wiiremote;

// コンストラクタ
WMDSwingSample::WMDSwingSample()
{
	mNote = SMP_DOWN;
}

void WMDSwingSample::task()
{
// Ａボタンが押されたらサンプルを鳴らす
	if(wiiremote.buttonClicked(WIIREMOTE_A) == true)
	{
		Midiout.noteOn(MIDICHANNEL,mNote,127);
		Midiout.noteOff(MIDICHANNEL,mNote,127);
	}

	
// 十字キー＆１，２キーでサンプルの設定
	if(wiiremote.buttonClicked(WIIREMOTE_DOWN) == true)
	{	mNote = SMP_DOWN;	}

	if(wiiremote.buttonClicked(WIIREMOTE_LEFT) == true)
	{	mNote = SMP_LEFT;	}

	if(wiiremote.buttonClicked(WIIREMOTE_UP) == true)
	{	mNote = SMP_UP;	}

	if(wiiremote.buttonClicked(WIIREMOTE_RIGHT) == true)
	{	mNote = SMP_RIGHT;	}

	if(wiiremote.buttonClicked(WIIREMOTE_ONE) == true)
	{	mNote = SMP_ONE;	}

	if(wiiremote.buttonClicked(WIIREMOTE_TWO) == true)
	{	mNote = SMP_TWO;	}

	
}


void WMDSwingSample::HammerEd()
{
	// 振り回しによるサンプルの再生
	// Ｂボタンを押している間のみサンプル再生
	if(wiiremote.buttonPressed(WIIREMOTE_B) == true)
	{
		Midiout.noteOn(MIDICHANNEL,mNote,127);
		Midiout.noteOff(MIDICHANNEL,mNote,127);
	}
//	Serial.print("HammerEd\r\n");
}
